CREATE OR REPLACE PROCEDURE JEFY_MARCHES.MAJ_MAPA_CE_NACRES_2014 AS 
CURSOR C1
  IS SELECT MCE.*
    FROM JEFY_MARCHES.MAPA_CE MCE 
    INNER JOIN JEFY_MARCHES.CODE_EXER CE ON MCE.CE_ORDRE = CE.CE_ORDRE 
    INNER JOIN JEFY_MARCHES.CODE_MARCHE CM ON CE.CM_ORDRE = CM.CM_ORDRE
    WHERE CE.EXE_ORDRE = 2013 AND CE_SUPPR = 'N';
  
  CURRENT_MCE JEFY_MARCHES.MAPA_CE%ROWTYPE;
  CE_ORDRE_NACRES INTEGER;
  CPT INTEGER;
  
BEGIN
  OPEN C1;
      LOOP
        FETCH C1 INTO CURRENT_MCE;
        EXIT WHEN C1%NOTFOUND;
        
        
        BEGIN
          -- VÉRIFICATION DE L'EXITENCE D'UNE CORRESPONDANCE NACRES
          SELECT CE2.CE_ORDRE INTO CE_ORDRE_NACRES
          FROM JEFY_MARCHES.CODE_MARCHE CM1, JEFY_MARCHES.CODE_MARCHE CM2, JEFY_MARCHES.CODE_EXER CE1, JEFY_MARCHES.CODE_EXER CE2, JEFY_MARCHES.CORRESPONDANCE_CN COCN
          WHERE CE1.CM_ORDRE = CM1.CM_ORDRE AND CM1.CM_CODE = COCN.ANCIEN_CN AND COCN.CN_NACRES=CM2.CM_CODE AND CM2.CM_ORDRE = CE2.CM_ORDRE AND CE1.CE_ORDRE = CURRENT_MCE.CE_ORDRE;
          
          -- VÉRIFICATION DE L'EXITENCE D'UNE ENTRÉE DANS CODE_MARCHE_FOUR
          SELECT COUNT(*) INTO CPT FROM JEFY_MARCHES.MAPA_CE WHERE MTE_ID=CURRENT_MCE.MTE_ID AND CE_ORDRE=CE_ORDRE_NACRES;
          
          IF(CPT>0) THEN
              DBMS_OUTPUT.PUT_LINE ('UN MAPA_CE EXISTE DÉJÀ POUR 2014 AVEC CETTE NOMENCLATURE NACRES, MTE_ID  : '||CURRENT_MCE.MTE_ID||', CE_ORDRE  : '||CURRENT_MCE.CE_ORDRE||'');
          
          ELSE
              INSERT INTO JEFY_MARCHES.MAPA_CE (MC_ID, CE_ORDRE, MTE_ID, DATE_MODIFICATION, UTL_ORDRE, MC_SUPP)
              VALUES (MAPA_CE_SEQ.NEXTVAL, CE_ORDRE_NACRES, CURRENT_MCE.MTE_ID, CURRENT_MCE.DATE_MODIFICATION, CURRENT_MCE.UTL_ORDRE, CURRENT_MCE.MC_SUPP) ;
              DBMS_OUTPUT.PUT_LINE(CE_ORDRE_NACRES);
  
          END IF;
            
            
          EXCEPTION
          WHEN NO_DATA_FOUND THEN
                DBMS_OUTPUT.PUT_LINE ('PAS DE CORRESPONDANCE NACRES, CE_ORDRE  : '||CURRENT_MCE.CE_ORDRE||'');
        END;
        
    END LOOP;
  CLOSE C1;
END MAJ_MAPA_CE_NACRES_2014;